/* --------------------------------------------------------------
    Signed integers with unlimited range.
    Service functions.

    http://www.imach.uran.ru/cbignum

    Copyright 1999-2003 by Raul N.Shakirov, IMach of RAS(UB).
    All Rights Reserved.

    Permission has been granted to copy, distribute and modify
    software in any context without fee, including a commercial
    application, provided that the aforesaid copyright statement
    is present here as well as exhaustive description of changes.

    THE SOFTWARE IS DISTRIBUTED "AS IS". NO WARRANTY OF ANY KIND
    IS EXPRESSED OR IMPLIED. YOU USE AT YOUR OWN RISK. THE AUTHOR
    WILL NOT BE LIABLE FOR DATA LOSS, DAMAGES, LOSS OF PROFITS OR
    ANY OTHER KIND OF LOSS WHILE USING OR MISUSING THIS SOFTWARE.
-------------------------------------------------------------- */
#ifdef  _MSC_VER
#pragma warning(disable:4995)
#endif/*_MSC_VER*/
#include <limits.h>
#include "Cbignum.h"

#ifdef  __BORLANDC__
#if     __BORLANDC__==0x460
#if     sizeof(int)==4
#define _CBIGNUM_ASM
#pragma inline
#endif
#endif
#endif

#include "Cbignumf.inl"

#ifdef  _CBIGNUM_ASM

#ifdef  NCHECKPTR
#ifdef  __cplusplus
extern "C" {
#endif
#endif

#define UNROLL  3
#define UN      8
#define UNH     20H

void    cBigNumberMAddM  (
                        long*   p1,
                const   long*   p2,
                        size_t  k2
        )
{
  const long* pp = p1 + (size_t)(*p1);
  size_t n2 = (size_t)(*p2);
  p1 += k2;
  p1 += _cBigNumberSkip;
  p2 += _cBigNumberSkip;
  {
    _EBX = _ESI = n2 -_cBigNumberSkip;
    _EBX >>= UNROLL;        _EDI = p2 [0];
    ++_EBX;                 _EAX = p1 [0];
    if ((_ESI &= (UN-1)) == 0)         {  goto go0; }
    if (--_ESI == 0) { p1 -= 7; p2 -= 7;  goto go7; }
    if (--_ESI == 0) { p1 -= 6; p2 -= 6;  goto go6; }
    if (--_ESI == 0) { p1 -= 5; p2 -= 5;  goto go5; }
    if (--_ESI == 0) { p1 -= 4; p2 -= 4;  goto go4; }
    if (--_ESI == 0) { p1 -= 3; p2 -= 3;  goto go3; }
    if (--_ESI == 0) { p1 -= 2; p2 -= 2;  goto go2; }
                     { p1 -= 1; p2 -= 1;  goto go1; }
    for (;;)
    {
      __asm adc eax, edi;   _EDI = p2 [1];
      p1 [0] = _EAX;        _EAX = p1 [1];
go1:  __asm adc eax, edi;   _EDI = p2 [2];
      p1 [1] = _EAX;        _EAX = p1 [2];
go2:  __asm adc eax, edi;   _EDI = p2 [3];
      p1 [2] = _EAX;        _EAX = p1 [3];
go3:  __asm adc eax, edi;   _EDI = p2 [4];
      p1 [3] = _EAX;        _EAX = p1 [4];
go4:  __asm adc eax, edi;   _EDI = p2 [5];
      p1 [4] = _EAX;        _EAX = p1 [5];
go5:  __asm adc eax, edi;   _EDI = p2 [6];
      p1 [5] = _EAX;        _EAX = p1 [6];
go6:  __asm adc eax, edi;   _EDI = p2 [7];
      p1 [6] = _EAX;        _EAX = p1 [7];
go7:  __asm adc eax, edi;   _EDI = p2 [8];
      p1 [7] = _EAX;        _EAX = p1 [8];
#ifdef  __BORLANDC__
      __asm db 8DH,52H,UNH,8DH,49H,UNH;
#else
      __asm adc esi, esi;
      p1 += UN;             p2 += UN;
      __asm shr esi, 1;
#endif
go0:  if (--_EBX == 0) break;
    }
      __asm adc eax, edi;
      p1 [0] = _EAX;
      __asm sbb esi, esi;
  }

  if ((long)(_EDI ^= _ESI) < 0)
  {
    register long lp1;
    if ((long)_ESI < 0)
    {
      do
      {
        if (p1 == pp) break;
        lp1 = *++p1;
      }
      while ((~(*p1 = lp1 + 1) & lp1) < 0);
    }
    else
    {
      do
      {
        if (p1 == pp) break;
        lp1 = *++p1;
      }
      while ((~(*p1 = lp1 - 1) | lp1) >= 0);
    }
  }
}

size_t  _cBigNumberMSubD (
                        long*   p1,
                const   long*   p2,
                        size_t  k2
        )
{
  size_t n2 = (size_t)(*p2);
  p1 += k2;
  p1 += _cBigNumberSkip;
  p2 += _cBigNumberSkip;
  {
    _EBX = _ESI = n2 -_cBigNumberSkip;
    _EBX >>= UNROLL;        _EDI = p2 [0];
    ++_EBX;                 _EAX = p1 [0];
    if ((_ESI &= (UN-1)) == 0)         {  goto go0; }
    if (--_ESI == 0) { p1 -= 7; p2 -= 7;  goto go7; }
    if (--_ESI == 0) { p1 -= 6; p2 -= 6;  goto go6; }
    if (--_ESI == 0) { p1 -= 5; p2 -= 5;  goto go5; }
    if (--_ESI == 0) { p1 -= 4; p2 -= 4;  goto go4; }
    if (--_ESI == 0) { p1 -= 3; p2 -= 3;  goto go3; }
    if (--_ESI == 0) { p1 -= 2; p2 -= 2;  goto go2; }
                     { p1 -= 1; p2 -= 1;  goto go1; }
    for (;;)
    {
      __asm sbb eax, edi;   _EDI = p2 [1];
      p1 [0] = _EAX;        _EAX = p1 [1];
go1:  __asm sbb eax, edi;   _EDI = p2 [2];
      p1 [1] = _EAX;        _EAX = p1 [2];
go2:  __asm sbb eax, edi;   _EDI = p2 [3];
      p1 [2] = _EAX;        _EAX = p1 [3];
go3:  __asm sbb eax, edi;   _EDI = p2 [4];
      p1 [3] = _EAX;        _EAX = p1 [4];
go4:  __asm sbb eax, edi;   _EDI = p2 [5];
      p1 [4] = _EAX;        _EAX = p1 [5];
go5:  __asm sbb eax, edi;   _EDI = p2 [6];
      p1 [5] = _EAX;        _EAX = p1 [6];
go6:  __asm sbb eax, edi;   _EDI = p2 [7];
      p1 [6] = _EAX;        _EAX = p1 [7];
go7:  __asm sbb eax, edi;   _EDI = p2 [8];
      p1 [7] = _EAX;        _EAX = p1 [8];
#ifdef  __BORLANDC__
      __asm db 8DH,52H,UNH,8DH,49H,UNH;
#else
      __asm adc esi, esi;
      p1 += UN;             p2 += UN;
      __asm shr esi, 1;
#endif
go0:  if (--_EBX == 0) break;
    }
      __asm sbb eax, edi;
      p1 [0] = _EAX;
  }

  {
    register long pass = _EAX;
    register size_t n1 = n2 + k2;

    for (;;)
    {
      register long lp1;
      register long lp2;
      if (--n1 == 0)    break;
      lp2 = p1[-1];     --p1;
      lp1 = pass;       pass = lp2;
      lp2 >>= BITS-1;
      if (lp1 != lp2)   break;
    }
    return (n1 + 1);
  }
}

size_t  _cBigNumberMMul2M (
                        long*   p1
        )
{
  size_t n1 = (size_t)(*p1);
  p1 += _cBigNumberSkip;
  {
    _EBX = _ESI = n1 -_cBigNumberSkip;
    _EBX >>= UNROLL;
    ++_EBX;                 _EAX = p1 [0];
    if ((_ESI &= (UN-1)) == 0)         {  goto go0; }
    if (--_ESI == 0) { p1 -= 7;           goto go7; }
    if (--_ESI == 0) { p1 -= 6;           goto go6; }
    if (--_ESI == 0) { p1 -= 5;           goto go5; }
    if (--_ESI == 0) { p1 -= 4;           goto go4; }
    if (--_ESI == 0) { p1 -= 3;           goto go3; }
    if (--_ESI == 0) { p1 -= 2;           goto go2; }
                     { p1 -= 1;           goto go1; }
    for (;;)
    {
      __asm rcl eax, 1;
      p1 [0] = _EAX;        _EAX = p1 [1];
go1:  __asm rcl eax, 1;
      p1 [1] = _EAX;        _EAX = p1 [2];
go2:  __asm rcl eax, 1;
      p1 [2] = _EAX;        _EAX = p1 [3];
go3:  __asm rcl eax, 1;
      p1 [3] = _EAX;        _EAX = p1 [4];
go4:  __asm rcl eax, 1;
      p1 [4] = _EAX;        _EAX = p1 [5];
go5:  __asm rcl eax, 1;
      p1 [5] = _EAX;        _EAX = p1 [6];
go6:  __asm rcl eax, 1;
      p1 [6] = _EAX;        _EAX = p1 [7];
go7:  __asm rcl eax, 1;
      p1 [7] = _EAX;        _EAX = p1 [8];
#ifdef  __BORLANDC__
      __asm db 8DH,52H,UNH;
#else
      __asm adc esi, esi;
      p1 += UN;
      __asm shr esi, 1;
#endif
go0:  if (--_EBX == 0) break;
    }
      __asm rcl eax, 1;
      p1 [0] = _EAX;
      __asm sbb esi, esi;
  }

  p1 [1] = _ESI;
  n1 += ((long)(_EAX ^= _ESI) < 0);

  return (n1);
}

size_t  _cBigNumberMDiv2D (
                        long*   p1
        )
{
  size_t n1 = (size_t)(*p1);
  p1 += n1;
  size_t n = n1 - ((n1 > 1) & (*p1 == (*p1 >> 1)));
  {
    _EBX = _ESI = n1 - _cBigNumberSkip;
    _EBX >>= UNROLL;
    ++_EBX;                 _EAX = p1 [0];
    if ((_ESI &= (UN-1)) == 0)         { __asm sar eax, 1; goto go0; }
    if (--_ESI == 0) { p1 += 7;          __asm sar eax, 1; goto go7; }
    if (--_ESI == 0) { p1 += 6;          __asm sar eax, 1; goto go6; }
    if (--_ESI == 0) { p1 += 5;          __asm sar eax, 1; goto go5; }
    if (--_ESI == 0) { p1 += 4;          __asm sar eax, 1; goto go4; }
    if (--_ESI == 0) { p1 += 3;          __asm sar eax, 1; goto go3; }
    if (--_ESI == 0) { p1 += 2;          __asm sar eax, 1; goto go2; }
                     { p1 += 1;          __asm sar eax, 1; goto go1; }
    for (;;)
    {
      p1 [ 0] = _EAX;       _EAX = p1 [-1];
      __asm rcr eax, 1;
go1:  p1 [-1] = _EAX;       _EAX = p1 [-2];
      __asm rcr eax, 1;
go2:  p1 [-2] = _EAX;       _EAX = p1 [-3];
      __asm rcr eax, 1;
go3:  p1 [-3] = _EAX;       _EAX = p1 [-4];
      __asm rcr eax, 1;
go4:  p1 [-4] = _EAX;       _EAX = p1 [-5];
      __asm rcr eax, 1;
go5:  p1 [-5] = _EAX;       _EAX = p1 [-6];
      __asm rcr eax, 1;
go6:  p1 [-6] = _EAX;       _EAX = p1 [-7];
      __asm rcr eax, 1;
go7:  p1 [-7] = _EAX;       _EAX = p1 [-8];
      __asm rcr eax, 1;
#ifdef  __BORLANDC__
      __asm db 8DH,52H,-UNH;
#else
      __asm adc esi, esi;
      p1 -= UN;
      __asm shr esi, 1;
#endif
go0:  if (--_EBX == 0) break;
    }
      p1 [0] = _EAX;
  }

  return n;
}

#ifdef  NCHECKPTR
#ifdef  __cplusplus
}
#endif
#endif

#ifndef NCHECKPTR
#ifdef  __cplusplus
extern "C" {
#endif

void    cBigNumberMAddM (
                        EXPTR(long) p1,
                const   EXPTR(long) p2,
                        size_t k2
        )
{
  assert (_cBigNumberSkip > 0);
  size_t n1 = (size_t)(*p1);
  size_t n2 = (size_t)(*p2);
  assert (n1 >= n2 + k2);
  assert (n2 > 0);
  p1 [n1];
  p2 [n2];
  cBigNumberMAddM (EXPTRBASE(p1), EXPTRBASE(p2), k2);
}

size_t  _cBigNumberMSubD (
                        EXPTR(long) p1,
                const   EXPTR(long) p2,
                        size_t k2
        )
{
  assert (_cBigNumberSkip > 0);
  size_t n1 = (size_t)(*p1);
  size_t n2 = (size_t)(*p2);
  assert ((p1 [n1] ^ p2 [n2]) >= 0);
  assert (n1 >= n2 + k2);
  assert (n2 > 0);
  p1 [n1];
  p2 [n2];
  return _cBigNumberMSubD (EXPTRBASE(p1), EXPTRBASE(p2), k2);
}

size_t  _cBigNumberMMul2M (
                        EXPTR(long) p1
        )
{
  assert (_cBigNumberSkip > 0);
  size_t n1 = (size_t)(*p1);
  assert (n1 >= _cBigNumberSkip);
  p1 [n1 + 1];
  return _cBigNumberMMul2M (EXPTRBASE(p1));
}

size_t  _cBigNumberMDiv2D (
                        EXPTR(long) p1
        )
{
  assert (_cBigNumberSkip > 0);
  size_t n1 = (size_t)(*p1);
  assert (n1 >= _cBigNumberSkip);
  assert ((p1 [_cBigNumberSkip] & 1L) == 0);
  p1 [n1];
  return _cBigNumberMDiv2D (EXPTRBASE(p1));
}

#ifdef  __cplusplus
}
#endif
#endif

#endif
