//////////////////////////////////////////////////////////////////////////
// BMP.H: Header File
//////////////////////////////////////////////////////////////////////////

#ifndef __WIN32__

typedef struct tagBITMAPFILEHEADER
{
        unsigned short	bfType;                   // "BM" or 0x4D42
        unsigned long	bfSize;                   // Size of file in bytes
        unsigned short	bfReserved1;              // Set to 0
        unsigned short	bfReserved2;              // Set to 0
        unsigned long bfOffBits;                  // Offset in file where
                                                  // the bits begin
} BITMAPFILEHEADER;

typedef struct tagBITMAPINFOHEADER
{
        unsigned long	biSize;                   // Size of the structure
        unsigned long	biWidth;                  // Width in pixels
        unsigned long	biHeight;                 // Height in pixels
        unsigned short	biPlanes;                 // # of color Planes: Set to 1
        unsigned short	biBitCount;               // Color bits per pixel
        unsigned long	biCompression;            // Compression Scheme
        unsigned long	biSizeImage;              // Number of bitmap bytes
        unsigned long	biXPelsPerMeter;          // Horizontal Resolution
        unsigned long	biYPelsPerMeter;          // Vertical Resolution
        unsigned long	biClrUsed;                // Number of colors used
        unsigned long	biClrImportant;           // Important colors

} BITMAPINFOHEADER;

typedef struct tagRGBQUAD {
    char    rgbBlue;
    char    rgbGreen;
    char    rgbRed;
    char    rgbReserved;
} RGBQUAD;
#else
#include <windows.h>
#endif


#ifndef BMP_OK
#define BMP_OK -1
#define BMP_BadDriver 0
#define BMP_TooBig 1
#define BMP_WrongVideo 2
#define BMP_Compression 3
#endif

