/*      exalloc.h

        ᪮ ।   ࠡ⪮ 訡.

        (C) ..஢,   PAH, 1994 - 2000
        All Rights Reserved.
*/
#ifndef EXALLOC_H
#define EXALLOC_H

#include <limits.h>

#ifndef _EXDEF_H
#include <exdef.h>
#endif

//------------------------------------------------
//  譨 뫪 ,  "C", ⮡
//  ஢ ८ࠧ .
//    ७ ꥪ 㫨
//   ࠧ묨 ﬨ ஢.

#ifdef  __cplusplus
extern "C" {
#endif

#ifndef EXALLOC_H_MAIN
#define EXALLOC_H_MAIN

/* --------------------------------------------------------------
    譨 뫪 ,  "C", ⮡
    ஢ ८ࠧ .
      ७ ꥪ 㫨
     ࠧ묨 ﬨ ஢.
-------------------------------------------------------------- */

#ifdef  __cplusplus
extern "C" {
#endif/*__cplusplus*/

/* --------------------------------------------------------------
    , 筠 ᪮
    ᨢ   ⮢.
-------------------------------------------------------------- */

struct  exblock_t { void* e; size_t len; };

/* --------------------------------------------------------------
    ᪨ NULL-ᨢ.
-------------------------------------------------------------- */

extern struct  exblock_t VDECL exnull_c;

/* --------------------------------------------------------------
    㭪 set_exalloc_handler() ⠭
    ࠡ稪 訡 । ,
     set_new_handler().
-------------------------------------------------------------- */

extern  void (* set_exalloc_handler (void (*pvf) (void))) (void);

/* --------------------------------------------------------------
    ࠡ稪  訡  ᢥ
    o । .

    exalloc_status.size_handler
        ⥫ ᪮ 㭪樨, 뢠
         墠⪥ . 㭪  㤨
        ᪫祭  ४ ࠡ ணࠬ.

    exalloc_status.grow_handler
        ⥫ ᪮ 㭪樨, 뢠
         ⮬᪮ 㢥祭 ࠧ ᨢ
         NULL, ᫨ 맮 ᪮ 㭪樨
         ॡ.  ਬ  ஢
        ⮬᪮ 㢥祭 ࠧ.

    exalloc_status.null_handler
        ⥫ 㭪樨, 뢠  饭
         NULL-㪠⥫. 㭪  㤨
        ᪫祭  ४ ࠡ ணࠬ.

    exalloc_status.range_handler
        ⥫ 㭪樨, 뢠  室
          ࠭ ᨢ  ⮬ 砥, ᫨
         ।ᬮ७ ⮬᪮ 㢥祭
        ࠧ ᨢ. 㭪  㤨
        ᪫祭  ४ ࠡ ணࠬ.
-------------------------------------------------------------- */

struct  exalloc_status_t
{
    void (* VDECL size_handler)(void);
    void (* VDECL grow_handler)(void);
    void (* VDECL null_handler)(void);
    void (* VDECL range_handler)(void);
    char*  pMinAlloc;               /*   */
    char*  pMaxAlloc;               /* ᨬ  */
    int    nBlocksAllocated;        /* ᫮ ।  */
    int    nBlocksFailed;           /* ᫮ 訡 । */
};
extern struct exalloc_status_t exalloc_status;

/* --------------------------------------------------------------
    㭪 exmalloc() 뤥  ,
     ﬨ.

    㭪 exmrealloc() 뤥, 㤫,
    㪮稢  ᢮  ,
     ⠪   ⮪.

        .
     ९ ࠧ來 ⪨ 
    墠⪥  뢠 ࠡ稪 訡,
    ⠭  exalloc_set_handler, 
    ᢮ exalloc_status.size_handler.

    㭪 exfree() ᢮  .

    ᨨ aligned  㪠 ࠢ.
-------------------------------------------------------------- */

void*   FCDECL  exmalloc           (size_t blocksize);
void*   FCDECL  exaligned_malloc   (size_t blocksize, size_t blockalign);

void    FCDECL  exmrealloc         (void** p,
                                    size_t blocksize,
                                    size_t memset_start,
                                    size_t memset_stop);
void    FCDECL  exaligned_mrealloc (void** p,
                                    size_t blocksize, size_t blockalign,
                                    size_t memset_start,
                                    size_t memset_stop);

void    FCDECL  exfree             (void* p);
void    FCDECL  exaligned_free     (void* p);

/* --------------------------------------------------------------
    㭪 exrange() 뢠
    exalloc_status.null_handler 
    exalloc_status.range_handler.
-------------------------------------------------------------- */

void    FCDECL  exrange (void* p);

/* --------------------------------------------------------------
    ࠬ । ᪮ .

    EXSIZE_T_MAX        - ᨬ쭮 祭,
            뤠  ⢥ १
            楫᫥ ᫥  ஫
            ९ ࠧ來 ⪨.
    EXARRAY_ALIGN       - ࠢ  ,
            ।塞  o ᨢ.
            ⨬ 祭 - 1, 2, 4, 8, 16.
    EXCALCBLOCKSIZE_SYS - ࠧ ⥬
              , 騩
             ਬ塞  (᫨
            ࠧ ⥭,   㪠
             業,    16).
    EXCALCBLOCKSIZE_MOD - 砫 ࠧ
               ⮬ ⥬
                
            㭪樨 excalcblocksize, 
            64**n +/- 16 .
    EXCALCBLOCKSIZE1..5 -  砫 ࠧ
                ⥬
            , ⠭  
            㭪樨 excalcblocksize  ᪮쪮
            ᫥ ࠧ஢, 뤠
            ⮩  㭪樥.
    EXCALCBLOCKSIZE_MAX - ᨬ ࠧ
                ⥬
            ,  ᪠
            㭪ﬨ । 
            (樮 ⥬  
             뢠 ⥫
            ࠭祭).
-------------------------------------------------------------- */

#define EXSIZE_T_MAX        ((sizeof(size_t)==2)? UINT_MAX: INT_MAX)
#define EXARRAY_ALIGN       ((sizeof(size_t)==2)? 1: 16)
#define EXCALCBLOCKSIZE_SYS (sizeof(size_t) * 2)
#define EXCALCBLOCKSIZE_MOD (sizeof(size_t) * 32 - 16)
#define EXCALCBLOCKSIZE_1   (EXCALCBLOCKSIZE_MOD * 1 - EXCALCBLOCKSIZE_SYS)
#define EXCALCBLOCKSIZE_2   (EXCALCBLOCKSIZE_MOD * 2 - EXCALCBLOCKSIZE_SYS)
#define EXCALCBLOCKSIZE_3   (EXCALCBLOCKSIZE_MOD * 3 - EXCALCBLOCKSIZE_SYS)
#define EXCALCBLOCKSIZE_4   (EXCALCBLOCKSIZE_MOD * 6 - EXCALCBLOCKSIZE_SYS)
#define EXCALCBLOCKSIZE_5   (EXCALCBLOCKSIZE_MOD * 9 - EXCALCBLOCKSIZE_SYS)
#define EXCALCBLOCKSIZE_MAX (EXSIZE_T_MAX - EXCALCBLOCKSIZE_SYS * 2)

/* --------------------------------------------------------------
    㭪 excalcblocksize() 뢠
    ⨬ ࠧ    ,
         ॡ㥬.
    ᫨ 襭 ࠧ ᫨誮 ,
     뤠 EXSIZE_T_MAX.
-------------------------------------------------------------- */

size_t  FCDECL  excalcblocksize (size_t blocksize);

/* --------------------------------------------------------------
    ᫥ ᫥  ஫
    ९ ࠧ來 ⪨.
      exmuladd (s,n,k)   = s * n + k.
      exmul    (s,n)     = s * n.
      exadd    (n,k)     = n + k.
     ९ 뤠 EXSIZE_T_MAX.
      exchkadd (n,k,max) = n + k, ᫨ <= max,  訡.
     樨 ⨬쭮  ᫥ ᯮ짮
    ࠭ ++  ⠢ ⠭   s  k.
-------------------------------------------------------------- */

#ifndef __cplusplus
#define EXALLOC_OUT_OF_LINE
#endif/*__cplusplus*/

#ifdef  EXALLOC_OUT_OF_LINE

size_t  FCDECL  exmuladd (size_t s, size_t n, size_t k);
size_t  FCDECL  exmul    (size_t s, size_t n);
size_t  FCDECL  exadd    (size_t n, size_t k);
size_t  FCDECL  exchkadd (size_t n, size_t k, size_t max);

#else /*EXALLOC_OUT_OF_LINE*/

inline size_t exmuladd (size_t s, size_t n, size_t k)
{
    return ((n <= (EXSIZE_T_MAX - k) / s)? (n * s + k): EXSIZE_T_MAX);
}

inline size_t exmul (size_t s, size_t n)
{
    return ((s == 1)? n: (n <= EXSIZE_T_MAX / s)? n * s: EXSIZE_T_MAX);
}

inline size_t exadd (size_t n, size_t k)
{
    return ((n <= EXSIZE_T_MAX - k)? (n + k): EXSIZE_T_MAX);
}

inline size_t exchkadd (size_t n, size_t k, size_t max)
{
    if (n > max - k) (*::exalloc_status.size_handler)();
    return (n + k);
}

#endif/*EXALLOC_OUT_OF_LINE*/

/* --------------------------------------------------------------
    쭥訥 譨 뫪  ࠡ뢠
     ०  㬮砭.
-------------------------------------------------------------- */

#ifdef  __cplusplus
}
#endif/*__cplusplus*/

/* --------------------------------------------------------------
     EXALLOC_EXTRA_ITEMS(T) 
    ᫮ ⥫ 客
    ⮢  ᨢ  ⨯ T.
      ਭ 祭  0
     . ⭮ 祭 - 1.
-------------------------------------------------------------- */

#ifndef EXALLOC_EXTRA_ITEMS
#define EXALLOC_EXTRA_ITEMS(T)  (1)
#endif/*EXALLOC_EXTRA_ITEMS*/

/* --------------------------------------------------------------
     EXALLOC() 뤥  ﬨ
       ᨢ ⮢.

     EXREALLOC() 뤥, 㤫,
    㪮稢  ᢮  ,
     ⠪   ⮪.

     ,  ᫮ ⮢ n ⨯ .
    ⥫쭮  襭  ⮢
    뤥   EXALLOC_EXTRA_ITEMS(T)
    㫥 ⮢  ᫥ ⮬
    ᨢ.   뢠.

     ९ ࠧ來 ⪨ 
    墠⪥  뢠 㭪,
    ᢮ exalloc_status.size_handler.

     EXFREE() ᢮  
      뢠.

    ᨨ ALIGNED   ࠢ.
-------------------------------------------------------------- */

#define EXALLOC(T,n) ((T*) exmalloc (                                   \
                            exmuladd (sizeof(T), (n),                   \
                                EXALLOC_EXTRA_ITEMS(T) * sizeof(T))))

#define EXREALLOC(T,p,n,nstart,nstop) (exmrealloc (                     \
                            (void**)&(p),                               \
                            exmuladd (sizeof(T), (n),                   \
                                EXALLOC_EXTRA_ITEMS(T) * sizeof(T)),    \
                            sizeof(T) * (size_t)(nstart),               \
                            sizeof(T) * (size_t)(nstop)))

#define EXFREE(p)           exfree (p)

#define EXALIGNED_ALLOC(T,n,a) ((T*) exaligned_malloc (                 \
                            exmuladd (sizeof(T), (n),                   \
                                EXALLOC_EXTRA_ITEMS(T) * sizeof(T)),    \
                            (a)))

#define EXALIGNED_REALLOC(T,p,n,nstart,nstop,a) (exaligned_mrealloc (   \
                            (void**)&(p),                               \
                            exmuladd (sizeof(T), (n),                   \
                                EXALLOC_EXTRA_ITEMS(T) * sizeof(T)),    \
                            (a),                                        \
                            sizeof(T) * (size_t)(nstart),               \
                            sizeof(T) * (size_t)(nstop)))

#define EXALIGNED_FREE(p)   exaligned_free (p)

/* --------------------------------------------------------------
    쭥訥    㡫஢
     㣨 䠩.
-------------------------------------------------------------- */

#endif/*EXALLOC_H_MAIN*/

#define exalloc(T,blocksize) ((T*) exmalloc (exmul (sizeof(T),(blocksize))))

#define exrealloc(T,p,blocksize,memset_start,memset_stop) (     \
                exmrealloc ((void**)&(p),                       \
                        exmul (sizeof(T), (blocksize)),         \
                        sizeof(T) * (size_t)(memset_start),     \
                        sizeof(T) * (size_t)(memset_stop)))

//------------------------------------------------
//      ⥫ 㭪樨, 뢠 
//      訡 । .
//      㭪  㤨 ᪫祭
//       ४ 믮 ணࠬ.
//      ᫨ 㪠⥫ ࠢ NULL,  ࠡ⪠
//      믮 㭪樥, ⠭
//       set_new_handler  new.h, ᫨ 
//       ⠪ ,  뢠 abort().

extern  void (* VDECL exalloc_fail_handler)(void);

//------------------------------------------------
//  ⠭ 㭪樨 ࠡ⪨ 訡.

void    STDECL  exalloc_fail        (void); // exalloc_fail_handler
void    STDECL  exalloc_size_fail   (void); // exalloc_status.size_handler
void    STDECL  exalloc_stub        (void); // exalloc_status.grow_handler
void    STDECL  exalloc_null_fail   (void); // exalloc_status.null_handler
void    STDECL  exalloc_range_fail  (void); // exalloc_status.range_handler

//------------------------------------------------
//   ᫥ 襭  .
//    訡 ࠧ饭.

extern  size_t  exalloc_blocksize;

//------------------------------------------------
//  ।   
//  ࠡ⪨ 訡  ࠡ⪨ ᪫祭.
//  exalloc_success(t,n)    - ⪠
//  exalloc_result(t)       - १

#define exalloc_success(t,n)    (exmalloc_success (exmul (sizeof(t),(n))))
#define exalloc_result(t)   ((t*) exmalloc_result())
int     STDECL  exmalloc_success (size_t blocksize);
void*   STDECL  exmalloc_result  (void);

//------------------------------------------------
//  ஫ 
//  (믮 ⮫쪮  16-ࠧ來 ०).
//  excoreleft()    - ᮮ ꥬ 
//  excore_store()  -  ꥬ 
//  excore_clear()  - 㫨  ꥬ 
//  excore_check()  - ஢ ꥬ 
//  㭪樨 excore  excore_check ᫥ 뢠
//     ⮬  ஢  㭪権.

#ifndef __SEGMENT__
typedef unsigned    excoreleft_t;
#else
typedef unsigned long   excoreleft_t;
#endif

#ifdef  __FLAT__
#define excoreleft() (0)
#define excore_store()
#define excore_clear()
#define excore_check()
#else //__FLAT__
excoreleft_t STDECL excoreleft  (void);
void    STDECL  excore_store    (void);
void    STDECL  excore_clear    (void);
void    STDECL  excore_check    (void);
#endif//__FLAT__

//================================================
//  16-ࠧ來 㭪樨 । .
//================================================

#ifndef __STDC__
#ifndef __FLAT__
void far* STDECL exfarmalloc    (unsigned long blocksize);
void      STDECL exfarmrealloc  (void far **lp, unsigned long blocksize,
                 unsigned long memset_start,
                 unsigned long memset_stop);
void      STDECL exfarfree  (void far *lp);
#else //__FLAT__
#define exfarmalloc exmalloc
#define exfarmrealloc   exmrealloc
#define exfarfree   exfree
#endif//__FLAT__
#endif//__STDC__

//================================================
//  ஢ ப  । .
//================================================

char*   STDECL  exstrdup     (const char *src);

#ifdef __cplusplus
}
#endif

#endif//EXALLOC_H
