/*      exalloc2.cpp

        ।   ࠡ⪮ 訡.
        ᪨ 㭪樨.

        (C) ..஢,   PAH, 1998 - 2002
        All Rights Reserved.
*/
#include <exarray.h>
#include <exalloc.h>
#include <exdef.h>

#ifdef __cplusplus
extern "C" {
#endif

/* --------------------------------------------------------------
    誠 ᪮ ᨢ  ᢠ
    ᪨ 㪠⥫ 祭 NULL.
-------------------------------------------------------------- */

struct  exblock_t VDECL exnull_c;

/* --------------------------------------------------------------
    㭪 set_exalloc_handler() ⠭
    ࠡ稪 訡 । ,
     set_new_handler().

    ࠬ:
    pvf     ⥫  㭪 ⨯ void name (void) 
            NULL ᫨  ࠡ⪨ 訡 ᫥ 맢
            (*exalloc_status.size_handler)();

    뤠: ।騩 㪠⥫.
-------------------------------------------------------------- */

void (* set_exalloc_handler (void (*pvf) (void))) (void)
{
    static void (* pvfFailHandler)(void) = NULL;
    void (*pvfPrev) (void) = pvfFailHandler;
    pvfFailHandler = pvf;
    return pvfPrev;
}

/* --------------------------------------------------------------
    㭪 exalloc_size_fail() 뢠 ࠡ稪 訡
    ।    ,    ࠢ NULL,
    ⥬ 뢠 abort().
-------------------------------------------------------------- */

void exalloc_size_fail (void)
{
    for (;;)
    {
        void (*pvf) (void) = set_exalloc_handler (NULL);
        set_exalloc_handler (pvf);
        if (pvf == NULL) break;
        (*pvf)();
    }
    exalloc_fail();
}

/* --------------------------------------------------------------
    㭪 exalloc_stub()   祣.
-------------------------------------------------------------- */

void exalloc_stub (void) {}

/* --------------------------------------------------------------
    㭪 exalloc_null_fail() ࠡ뢠 訡
    饭  NULL-㪠⥫.
-------------------------------------------------------------- */

const   char    VDECL   szENULL    []="Null pointer access";

void    STDECL  exalloc_null_fail (void)
{
  exprintfail (szF1, szENULL);
}

/* --------------------------------------------------------------
    㭪 exalloc_range_fail ࠡ뢠 訡
    室   ࠭ ᨢ.
-------------------------------------------------------------- */

const   char    VDECL   szEINDEX   []="Index range error";

void    STDECL  exalloc_range_fail (void)
{
  exprintfail (szF1, szEINDEX);
}

/* --------------------------------------------------------------
    ࠡ稪  訡  ᢥ
    o । .

    ⥫ 㭪樨, 뢠  ࠭
    訡 । . 㭪  㤨
    ᪫祭  ४ ࠡ ணࠬ.

    ⥫ ᪮ 㭪樨, 뢠
     ⮬᪮ 㢥祭 ࠧ ᨢ
     NULL, ᫨ 맮 ᪮ 㭪樨
     ॡ.  ਬ  ஢
    ⮬᪮ 㢥祭 ࠧ.

    ⥫ 㭪樨, 뢠  饭
     NULL-㪠⥫. 㭪  㤨
    ᪫祭  ४ ࠡ ணࠬ.

    ⥫ 㭪樨, 뢠  室
      ࠭ ᨢ  ⮬ 砥, ᫨
     ।ᬮ७ ⮬᪮ 㢥祭
    ࠧ ᨢ. 㭪  㤨
    ᪫祭  ४ ࠡ ணࠬ.
-------------------------------------------------------------- */

struct exalloc_status_t exalloc_status =
    { exalloc_size_fail, exalloc_stub,
      exalloc_null_fail, exalloc_range_fail, 0, 0, 0, 0 };

/* --------------------------------------------------------------
    㭪 exrange() 뢠 exalloc_status.null_handler
     exalloc_status.range_handler  ᨬ  p.

    ࠬ:
    p              NULL.
-------------------------------------------------------------- */

void    FCDECL  exrange (void* p)
{
    if (p == NULL)
            (*exalloc_status.null_handler)();
    else    (*exalloc_status.range_handler)();
}

#ifdef __cplusplus
}
#endif
