/*	spk_fun.c

	䥩 ᨭ⥧ .

	(C) ..஢,   PAH, 1994 - 1999
	All Rights Reserved.
*/
#ifdef	__TURBOC__
#ifndef __FLAT__
#include <espeak.h>
#include <speak.h>
#include <exdef.h>
#include <spk_fun.h>

// =========================================================================
//	室 ࠬ ᨭ⥧ .
// =========================================================================
//	砫 祭.
#define iDEVICE	 	 4
#define iVOICE		 0
#define iPITCH		 4
#define iVOLUME		 9
#define iSPEED		 4
#define iCOMPASS	 2
#define iLPITCH		 0
short	cdecl	nSpeakEnglish =0;	//   -᪨.
short	cdecl	nSpeakDevice  =iDEVICE;	// ன⢮	(0...).
short	cdecl	nSpeakVoice   =iVOICE;	// 	(0..1).
short	cdecl	nSpeakPitch   =iPITCH;	// 	(0..9).
short	cdecl	nSpeakVolume  =iVOLUME;	// ஬	(0..9).
short	cdecl	nSpeakSpeed   =iSPEED;	// 	(0..9).
short	cdecl	nSpeakCompass =iCOMPASS;// ⮭	(0..9,⮫쪮 SDRV).
short	cdecl	nSpeakLowPitch=iLPITCH; // 	(0..9,⮫쪮 SDRV).

// =========================================================================
//	७ ࠬ ᨭ⥧  ( !).
// =========================================================================
//	࠭  ⥬ SDRV ( 㬥樨).
#define	minSpeakPitch   50
#define	maxSpeakPitch  500

//	  饭  ⥬ SDRV:
#define	cSpeakLowPitch  50
#define	dSpeakLowPitch   5

//	饭 ⥬ SDRV  ஢ 0  1
//	 (min, max) 뢠  㫠:
//	 = 饭 * (nSpeakPitch + 1)
//	min =  ⥬ + 
//	max =  ⥬ +  * (1 + nSpeakCompass / iCOMPASS)
//	 - ४  ࠭栬.
#define	dSpeakPitch0     8	//  iPITCH = 3  10
#define	dSpeakPitch1    28	//  iPITCH = 3  35

//	࠭  ⥬ SDRV (/, । ᪨!)
#define	minSpeakSpeed	50
#define	maxSpeakSpeed  125

//	  饭 ⥬ SYNTA (/, । ᪨!)
#define	cSpeakSpeed	50
#define	dSpeakSpeed	 5

// =========================================================================
//	室 ࠬ ᨭ⥧ .
// =========================================================================
int	bSpeakBreak	=   0;	// ਧ 뢠.
int	nSpeakDriver	=   0;	//  ᨨ .ࠩ  0.
int	nSpeakDriver2	=   0;	//  ᨨ .ࠩ  0.
int	estSpeakSpeed   =	//  ணਢ (/)
	cSpeakSpeed + dSpeakSpeed * (9 - iSPEED);

// =========================================================================
//	७ ६  㭪樨 ᨭ⥧ .
// =========================================================================
static	int	_nSpeakStatus = -1;	// ࠩ:0=,1=,2=,3=.

static	near	void	_AddSystemTime	(long dif)	// த 
{							// ।.
  struct time t;
  gettime (&t);

  dif /= 10;
  t.ti_hund += (unsigned char) (dif % 100); dif /= 100;
  if (t.ti_hund >= 100) {t.ti_hund -= 100; ++t.ti_sec; }
  t.ti_sec  += (unsigned char) (dif %  60); dif /=  60;
  if (t.ti_sec  >=  60) {t.ti_sec  -=  60; ++t.ti_min; }
  t.ti_min  += (unsigned char) (dif %  60); dif /=  60;
  if (t.ti_min  >=  60) {t.ti_min  -=  60; ++t.ti_hour;}
  t.ti_hour += (unsigned char) (dif %  24);
  t.ti_hour %= 24;

  settime (&t);
}

static	near	void	_spkSetParam (void)	// ⠭ ࠬ஢ SDRV
{
  unsigned n, max, min;
  SPKPARAM far* spk = spkGetCnf();

  if (spk->output != nSpeakDevice && spkSetOutput (nSpeakDevice) > 0)
    spkSetOutput (nSpeakDevice = spk->output);

  if (spk->voice != nSpeakVoice) spkSetVoice (nSpeakVoice);

  n = (nSpeakPitch + 1) * (nSpeakVoice ? dSpeakPitch1: dSpeakPitch0);
  min = cSpeakLowPitch + dSpeakLowPitch * nSpeakLowPitch + n;
  max = min + (n * nSpeakCompass) / iCOMPASS;
  if (min < minSpeakPitch) min = minSpeakPitch;
  if (max > maxSpeakPitch) max = maxSpeakPitch;
  spkSetPitch (min, max);

  spkSetVolume (nSpeakVolume * 85 / 3);

  spkSetTempo(((estSpeakSpeed - minSpeakSpeed) * 150) /
	       (maxSpeakSpeed - minSpeakSpeed));
}

static	near	int	_espkSetParam (void)	// ⠭ ࠬ஢ SYNTA
{
  int n = espkSetParam (
      nSpeakVolume, nSpeakSpeed, nSpeakPitch, nSpeakVoice, nSpeakDevice
      );
  if (n == 8) n = espkSetParam (
      nSpeakVolume, nSpeakSpeed, nSpeakPitch, nSpeakVoice, nSpeakDevice =-1
      );
  return (n);
}

static	near 	int	_ChkDrv	(void)		//  ࠩ஢.
{				       		// 0=,1=,2=,3=.
  if (_nSpeakStatus < 0)
  {
    nSpeakDriver  = spkGetVer();			// SDRV
    if (nSpeakDriver == 0) nSpeakDriver = 0x100;
    if (nSpeakDriver < 0xFF) nSpeakDriver = 0;
    _nSpeakStatus = (nSpeakDriver != 0);
    if (nSpeakDriver >= 0x104) _spkSetParam();		// SDRV 1.4

    nSpeakDriver2 = (_espkSetParam() == 1) ? 0 : 0x100;	// SYNTA
    if (nSpeakDriver2) _nSpeakStatus += 2;
  }
  return (_nSpeakStatus);
}

// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
//	㭪樨 ᨭ⥧ .
// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
int	pascal	ChkDrv	(void)	//  ࠩ஢.
{			// 뤠: -3=Windows 386,0=,1=,2=,3=
  union REGS regs;
  struct SREGS sregs;

  if (_ChkDrv())
  {						// Check for protected mode.
/*
    regs.x.ax = 0x160A;				// Windows 3.1 or above.
    int86x (0x2F, &regs, &regs, &sregs);
    if (regs.x.ax == 0 && regs.x.cx == 3) { _nSpeakStatus = 0; return -3; }
*/
    regs.x.ax = 0x1600;				// Windows 3.0 or above.
    int86x (0x2F, &regs, &regs, &sregs);
    if (regs.h.al != 0) { _nSpeakStatus = 0; return -3; }
  }

  return (_nSpeakStatus);
}

int	pascal	Speak	(char *psBuf)		// ணਢ ⥪.
{					        // 0=,1=,2=,3=.
  unsigned char	len = 0;			//  ⥪.
  int		eng = nSpeakEnglish;		//  ᪨ ⥪.
//
//  ।塞 ᪮ ணਢ  ஢塞 ᫮.
//
  estSpeakSpeed = cSpeakSpeed  + dSpeakSpeed * (9 - nSpeakSpeed);
//
//  塞 騥 ᨬ.
//
  if (_ChkDrv() && psBuf)
  {
    register char *ps1 = psBuf;
    register char *ps2 = psBuf;
//  register char bPress = 1;
    register char cPress;

    do
    {
       switch (cPress = *ps1++)
       {
	 case '\r':		continue;
	 case '\n':		cPress = ' ';
//	 case ' ':		if (bPress) continue;
//	 case '.': case ',':	bPress = 1; break;
//	 default:		bPress = 0;
       }
       if (eng >= 0)
       {
	 if (cPress >= '' && cPress <= '') eng = -1;
	 if (cPress >= 'A' && cPress <= 'Z' ||
	     cPress >= 'a' && cPress <= 'z') eng = 1;
       }
       if (++len == 0) { --len; cPress = 0; }
       *ps2++ = cPress;
    }
    while (cPress);
  }
//
//  ⠭ ⥬   ணਢ ⥪.
//
  if (len > 0)
  {
    struct time timer;			// .
    int		nTime = 0;		//  ४樨 ६.

    if (nSpeakDriver && (!nSpeakDriver2 || eng <= 0))
    {
      if (nSpeakDriver < 0x104) 	// SDRV 1.0
      {
	gettime (&timer); nTime = 100;
      }
      else				// SDRV 1.4
      {
	_spkSetParam(); if (bSpeakBreak) spkCont();
      }
      bSpeakBreak = (speak (len, psBuf) == 0x80);
    }
    else				// SYNTA.
    {
      _espkSetParam();
      gettime (&timer); nTime = estSpeakSpeed;
      espkSayText (psBuf); bSpeakBreak = 0;
    }
    if (nTime)				// ४㥬 ⥬ ६.
    {
      long time = GetTimer (&timer);

      if (time * 2 < ((long) len) * nTime)
	_AddSystemTime (((long) len) * nTime - time);
    }
    delay (1);				// প  ࠡ⪨ 뢠.
  }

  return (_nSpeakStatus);
}

void	pascal	SpeakBreak (int len, char *mcBrk)	//  ⠭.
{
  if (_ChkDrv() && nSpeakDriver >= 0x104) spkSetBrk (len, (key_t *) mcBrk);
}
#endif
#endif
